From 38f980f34bcd154ced8eea671eaea7a646af23f3 Mon Sep 17 00:00:00 2001 From: Paul Buetow Date: Fri, 21 Jul 2023 10:19:46 +0300 Subject: Update content for gemtext --- ...-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi | 103 + ...21-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl | 100 + .../DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi | 61 - ...FT-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl | 58 - gemfeed/atom.xml.tmp | 6700 +++++++++++++++++++- gemfeed/index.gmi | 1 + 6 files changed, 6891 insertions(+), 132 deletions(-) create mode 100644 gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi create mode 100644 gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl delete mode 100644 gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi delete mode 100644 gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl (limited to 'gemfeed') diff --git a/gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi b/gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi new file mode 100644 index 00000000..1f3c3850 --- /dev/null +++ b/gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi @@ -0,0 +1,103 @@ +# Gemtexter 2.1.0 - Let's Gemtext again³ + +> Published at 2023-07-21T10:19:31+03:00 + +``` +-=[ typewriters ]=- 1/98 + .-------. + .-------. _|~~ ~~ |_ + _|~~ ~~ |_ .-------. =(_|_______|_) + =(_|_______|_)= _|~~ ~~ |_ |:::::::::| + |:::::::::| =(_|_______|_) |:::::::[]| + |:::::::[]| |:::::::::| |o=======.| + |o=======.| |:::::::[]| `"""""""""` + jgs `"""""""""` |o=======.| + mod. by Paul Buetow `"""""""""` +``` + +I proudly announce that I've released Gemtexter version `2.1.0`. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown, written in GNU Bash. + +=> https://codeberg.org/snonux/gemtexter + +## Why Bash? + +This project is too complex for a Bash script. Writing it in Bash was to try out how maintainable a "larger" Bash script could be. It's still pretty maintainable and helps me try new Bash tricks here and then! + +Let's list what's new! + +## Switch to GPL3 license + +Many (almost all) of the tools and commands (GNU Bash, GMU Sed, GNU Date, GNU Grep, GNU Source Highlight) used by `Gemtexter` are licensed under the GPL anyway. So why not use the same? This was an easy switch, as I was the only code contributor so far! + +## Source code highlighting support + +The HTML output now supports source code highlighting, which is pretty neat if your site is about programming. The requirement is to have the `source-highlight` command, which is GNU Source Highlight, to be installed. Once done, you can annotate a bare block with the language to be highlighted. E.g.: + +``` + ```bash + if [ -n "$foo" ]; then + echo "$foo" + fi + ``` +``` + +The result will look like this (you can see the code highlighting only in the Web version, not in the Geminispace version of this site): + +```bash +if [ -n "$foo" ]; then + echo "$foo" +fi +``` + +Please run `source-highlight --lang-list` for a list of all supported languages. + +## HTML exact variant + +Gemtexter is there to convert your Gemini Capsule into other formats, such as HTML and Markdown. An HTML exact variant can now be enabled in the `gemtexter.conf` by adding the line `declare -rx HTML_VARIANT=exact`. The HTML/CSS output changed to reflect a more exact Gemtext appearance and to respect the same spacing as you would see in the Geminispace. + +## Use of Hack webfont by default + +The Hack web font is a typeface designed explicitly for source code. It's a derivative of the Bitstream Vera and DejaVu Mono lineage, but it features many improvements and refinements that make it better suited to reading and writing code. + +The font has distinctive glyphs for every character, which helps to reduce confusion between similar-looking characters. For example, the characters "0" (zero), "O" (capital o), and "o" (lowercase o), or "1" (one), "l" (lowercase L), and "I" (capital i) all have distinct looks in Hack, making it easier to read and understand code at a glance. + +Hack is open-source and freely available for use and modification under the MIT License. + +## HTML Mastadon verification support + +The following link explains how URL verification works in Mastadon: + +=> https://joinmastodon.org/verification + +So we have to hyperlink to the Mastadon profile to be verified and also to include a `rel='me'` into the tag. In order to do that add this to the `gemtexter.conf` (replace the URI to your Mastadon profile accordingly): + +```bash +declare -xr MASTADON_URI='https://fosstodon.org/@snonux' +``` + +and add the following into your `index.gmi`: + +``` +=> https://fosstodon.org/@snonux Me at Mastaton +``` + +The resulting line in the HTML output will be something as follows: + +```html +Me at mastadon +``` + +## More + +Additionally, there were a couple of bug fixes, refactorings and overall improvements in the documentation made. + +Other related posts are: + +=> ./2023-03-25-gemtexter-2.0.0-lets-gemtext-again-2.gmi 2023-03-25 Gemtexter 2.0.0 - Let's Gemtext again² +=> ./2022-08-27-gemtexter-1.1.0-lets-gemtext-again.gmi 2022-08-27 Gemtexter 1.1.0 - Let's Gemtext again +=> ./2021-06-05-gemtexter-one-bash-script-to-rule-it-all.gmi 2021-06-05 Gemtexter - One Bash script to rule it all +=> ./2021-04-24-welcome-to-the-geminispace.gmi 2021-04-24 Welcome to the Geminispace + +E-Mail your comments to paul at buetow.org :-) + +=> ../ Back to the main site diff --git a/gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl b/gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl new file mode 100644 index 00000000..237b0254 --- /dev/null +++ b/gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl @@ -0,0 +1,100 @@ +# Gemtexter 2.1.0 - Let's Gemtext again³ + +> Published at 2023-07-21T10:19:31+03:00 + +``` +-=[ typewriters ]=- 1/98 + .-------. + .-------. _|~~ ~~ |_ + _|~~ ~~ |_ .-------. =(_|_______|_) + =(_|_______|_)= _|~~ ~~ |_ |:::::::::| + |:::::::::| =(_|_______|_) |:::::::[]| + |:::::::[]| |:::::::::| |o=======.| + |o=======.| |:::::::[]| `"""""""""` + jgs `"""""""""` |o=======.| + mod. by Paul Buetow `"""""""""` +``` + +I proudly announce that I've released Gemtexter version `2.1.0`. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown, written in GNU Bash. + +=> https://codeberg.org/snonux/gemtexter + +## Why Bash? + +This project is too complex for a Bash script. Writing it in Bash was to try out how maintainable a "larger" Bash script could be. It's still pretty maintainable and helps me try new Bash tricks here and then! + +Let's list what's new! + +## Switch to GPL3 license + +Many (almost all) of the tools and commands (GNU Bash, GMU Sed, GNU Date, GNU Grep, GNU Source Highlight) used by `Gemtexter` are licensed under the GPL anyway. So why not use the same? This was an easy switch, as I was the only code contributor so far! + +## Source code highlighting support + +The HTML output now supports source code highlighting, which is pretty neat if your site is about programming. The requirement is to have the `source-highlight` command, which is GNU Source Highlight, to be installed. Once done, you can annotate a bare block with the language to be highlighted. E.g.: + +``` + ```bash + if [ -n "$foo" ]; then + echo "$foo" + fi + ``` +``` + +The result will look like this (you can see the code highlighting only in the Web version, not in the Geminispace version of this site): + +```bash +if [ -n "$foo" ]; then + echo "$foo" +fi +``` + +Please run `source-highlight --lang-list` for a list of all supported languages. + +## HTML exact variant + +Gemtexter is there to convert your Gemini Capsule into other formats, such as HTML and Markdown. An HTML exact variant can now be enabled in the `gemtexter.conf` by adding the line `declare -rx HTML_VARIANT=exact`. The HTML/CSS output changed to reflect a more exact Gemtext appearance and to respect the same spacing as you would see in the Geminispace. + +## Use of Hack webfont by default + +The Hack web font is a typeface designed explicitly for source code. It's a derivative of the Bitstream Vera and DejaVu Mono lineage, but it features many improvements and refinements that make it better suited to reading and writing code. + +The font has distinctive glyphs for every character, which helps to reduce confusion between similar-looking characters. For example, the characters "0" (zero), "O" (capital o), and "o" (lowercase o), or "1" (one), "l" (lowercase L), and "I" (capital i) all have distinct looks in Hack, making it easier to read and understand code at a glance. + +Hack is open-source and freely available for use and modification under the MIT License. + +## HTML Mastadon verification support + +The following link explains how URL verification works in Mastadon: + +=> https://joinmastodon.org/verification + +So we have to hyperlink to the Mastadon profile to be verified and also to include a `rel='me'` into the tag. In order to do that add this to the `gemtexter.conf` (replace the URI to your Mastadon profile accordingly): + +```bash +declare -xr MASTADON_URI='https://fosstodon.org/@snonux' +``` + +and add the following into your `index.gmi`: + +``` +=> https://fosstodon.org/@snonux Me at Mastaton +``` + +The resulting line in the HTML output will be something as follows: + +```html +Me at mastadon +``` + +## More + +Additionally, there were a couple of bug fixes, refactorings and overall improvements in the documentation made. + +Other related posts are: + +<< template::inline::index gemtext gemini + +E-Mail your comments to paul at buetow.org :-) + +=> ../ Back to the main site diff --git a/gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi b/gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi deleted file mode 100644 index 1edaeb03..00000000 --- a/gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi +++ /dev/null @@ -1,61 +0,0 @@ -# Gemtexter 2.1.0 - Let's Gemtext again³ - -``` --=[ typewriters ]=- 1/98 - .-------. - .-------. _|~~ ~~ |_ - _|~~ ~~ |_ .-------. =(_|_______|_) - =(_|_______|_)= _|~~ ~~ |_ |:::::::::| - |:::::::::| =(_|_______|_) |:::::::[]| - |:::::::[]| |:::::::::| |o=======.| - |o=======.| |:::::::[]| `"""""""""` - jgs `"""""""""` |o=======.| - mod. by Paul Buetow `"""""""""` -``` - -I proudly announce that I've released Gemtexter version `2.1.0`. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown written in GNU Bash. - -=> https://codeberg.org/snonux/gemtexter - -Let's list what's new! - -## Switch to GPL3 license - -Many of the tools and commands (GNU Bash, GMU Sed, GNU Date, GNU Grep, GNU Source Highlight) used by `Gemtexter` are licensed under the GPL anyway. So why not use the same? This was an easy switch, as I was the only code contributor so far! - -## Source code highlighting support - -The HTML output now supports source code highlighting, which is pretty neat if your site is about programming. The requirement is to have the `source-highlight` command, which is GNU Source Highlight, to be installed. Once done, you can annotate a bare block with the language to be highlighted. E.g.: - -``` - ```bash - if [ -n "$foo" ]; then - echo "$foo" - fi - ... -``` - -Please run `source-highlight --lang-list` for a list of all supported languages. - -## HTML exact style - -The resulting HTML has changed. - -### Use of Hack webfont by default - -## Mastadon verification support - -## More - -Additionally, there were a couple of bug fixes, refactorings and overall improvements in the documentation made. - -Other related posts are: - -=> ./2023-03-25-gemtexter-2.0.0-lets-gemtext-again-2.gmi 2023-03-25 Gemtexter 2.0.0 - Let's Gemtext again² -=> ./2022-08-27-gemtexter-1.1.0-lets-gemtext-again.gmi 2022-08-27 Gemtexter 1.1.0 - Let's Gemtext again -=> ./2021-06-05-gemtexter-one-bash-script-to-rule-it-all.gmi 2021-06-05 Gemtexter - One Bash script to rule it all -=> ./2021-04-24-welcome-to-the-geminispace.gmi 2021-04-24 Welcome to the Geminispace - -E-Mail your comments to paul at buetow.org :-) - -=> ../ Back to the main site diff --git a/gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl b/gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl deleted file mode 100644 index 0e8a945b..00000000 --- a/gemfeed/DRAFT-gemtexter-2.1.0-lets-gemtext-again-3.gmi.tpl +++ /dev/null @@ -1,58 +0,0 @@ -# Gemtexter 2.1.0 - Let's Gemtext again³ - -``` --=[ typewriters ]=- 1/98 - .-------. - .-------. _|~~ ~~ |_ - _|~~ ~~ |_ .-------. =(_|_______|_) - =(_|_______|_)= _|~~ ~~ |_ |:::::::::| - |:::::::::| =(_|_______|_) |:::::::[]| - |:::::::[]| |:::::::::| |o=======.| - |o=======.| |:::::::[]| `"""""""""` - jgs `"""""""""` |o=======.| - mod. by Paul Buetow `"""""""""` -``` - -I proudly announce that I've released Gemtexter version `2.1.0`. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown written in GNU Bash. - -=> https://codeberg.org/snonux/gemtexter - -Let's list what's new! - -## Switch to GPL3 license - -Many of the tools and commands (GNU Bash, GMU Sed, GNU Date, GNU Grep, GNU Source Highlight) used by `Gemtexter` are licensed under the GPL anyway. So why not use the same? This was an easy switch, as I was the only code contributor so far! - -## Source code highlighting support - -The HTML output now supports source code highlighting, which is pretty neat if your site is about programming. The requirement is to have the `source-highlight` command, which is GNU Source Highlight, to be installed. Once done, you can annotate a bare block with the language to be highlighted. E.g.: - -``` - ```bash - if [ -n "$foo" ]; then - echo "$foo" - fi - ... -``` - -Please run `source-highlight --lang-list` for a list of all supported languages. - -## HTML exact style - -The resulting HTML has changed. - -### Use of Hack webfont by default - -## Mastadon verification support - -## More - -Additionally, there were a couple of bug fixes, refactorings and overall improvements in the documentation made. - -Other related posts are: - -<< template::inline::index gemtext gemini - -E-Mail your comments to paul at buetow.org :-) - -=> ../ Back to the main site diff --git a/gemfeed/atom.xml.tmp b/gemfeed/atom.xml.tmp index 20cb849d..1b9df20a 100644 --- a/gemfeed/atom.xml.tmp +++ b/gemfeed/atom.xml.tmp @@ -1,18 +1,143 @@ - 2023-07-17T20:24:46+03:00 + 2023-07-21T10:19:31+03:00 foo.zone feed To be in the .zone! gemini://foo.zone/ + + Gemtexter 2.1.0 - Let's Gemtext again³ + + gemini://foo.zone/gemfeed/2023-07-21-gemtexter-2.1.0-lets-gemtext-again-3.gmi + 2023-07-21T10:19:31+03:00 + + Paul Buetow aka snonux + paul@dev.buetow.org + + I proudly announce that I've released Gemtexter version `2.1.0`. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown, written in GNU Bash. + +
+

Gemtexter 2.1.0 - Let's Gemtext again³


+
+
+-=[ typewriters ]=-  1/98
+                                        .-------.
+       .-------.                       _|~~ ~~  |_
+      _|~~ ~~  |_       .-------.    =(_|_______|_)
+    =(_|_______|_)=    _|~~ ~~  |_     |:::::::::|
+      |:::::::::|    =(_|_______|_)    |:::::::[]|
+      |:::::::[]|      |:::::::::|     |o=======.|
+      |o=======.|      |:::::::[]|     `"""""""""`
+ jgs  `"""""""""`      |o=======.|
+  mod. by Paul Buetow  `"""""""""`
+
+
+I proudly announce that I've released Gemtexter version 2.1.0. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown, written in GNU Bash.
+
+https://codeberg.org/snonux/gemtexter
+
+

Why Bash?


+
+This project is too complex for a Bash script. Writing it in Bash was to try out how maintainable a "larger" Bash script could be. It's still pretty maintainable and helps me try new Bash tricks here and then!
+
+Let's list what's new!
+
+

Switch to GPL3 license


+
+Many (almost all) of the tools and commands (GNU Bash, GMU Sed, GNU Date, GNU Grep, GNU Source Highlight) used by Gemtexter are licensed under the GPL anyway. So why not use the same? This was an easy switch, as I was the only code contributor so far!
+
+

Source code highlighting support


+
+The HTML output now supports source code highlighting, which is pretty neat if your site is about programming. The requirement is to have the source-highlight command, which is GNU Source Highlight, to be installed. Once done, you can annotate a bare block with the language to be highlighted. E.g.:
+
+
+ ```bash
+ if [ -n "$foo" ]; then
+   echo "$foo"
+ fi
+ ```
+
+
+The result will look like this (you can see the code highlighting only in the Web version, not in the Geminispace version of this site):
+
+ +
if [ -n "$foo" ]; then
+  echo "$foo"
+fi
+
+
+Please run source-highlight --lang-list for a list of all supported languages.
+
+

HTML exact variant


+
+Gemtexter is there to convert your Gemini Capsule into other formats, such as HTML and Markdown. An HTML exact variant can now be enabled in the gemtexter.conf by adding the line declare -rx HTML_VARIANT=exact. The HTML/CSS output changed to reflect a more exact Gemtext appearance and to respect the same spacing as you would see in the Geminispace.
+
+

Use of Hack webfont by default


+
+The Hack web font is a typeface designed explicitly for source code. It's a derivative of the Bitstream Vera and DejaVu Mono lineage, but it features many improvements and refinements that make it better suited to reading and writing code.
+
+The font has distinctive glyphs for every character, which helps to reduce confusion between similar-looking characters. For example, the characters "0" (zero), "O" (capital o), and "o" (lowercase o), or "1" (one), "l" (lowercase L), and "I" (capital i) all have distinct looks in Hack, making it easier to read and understand code at a glance.
+
+Hack is open-source and freely available for use and modification under the MIT License.
+
+

HTML Mastadon verification support


+
+The following link explains how URL verification works in Mastadon:
+
+https://joinmastodon.org/verification
+
+So we have to hyperlink to the Mastadon profile to be verified and also to include a rel='me' into the tag. In order to do that add this to the gemtexter.conf (replace the URI to your Mastadon profile accordingly):
+
+ +
declare -xr MASTADON_URI='https://fosstodon.org/@snonux'
+
+
+and add the following into your index.gmi:
+
+
+=> https://fosstodon.org/@snonux Me at Mastaton
+
+
+The resulting line in the HTML output will be something as follows:
+
+ +
<a href='https://fosstodon.org/@snonux' rel='me'>Me at mastadon</a>
+
+
+

More


+
+Additionally, there were a couple of bug fixes, refactorings and overall improvements in the documentation made.
+
+Other related posts are:
+
+2023-03-25 Gemtexter 2.0.0 - Let's Gemtext again²
+2022-08-27 Gemtexter 1.1.0 - Let's Gemtext again
+2021-06-05 Gemtexter - One Bash script to rule it all
+2021-04-24 Welcome to the Geminispace
+
+E-Mail your comments to paul at buetow.org :-)
+
+Back to the main site
+
+
+
'Software Developmers Career Guide & Soft Skills' book notes gemini://foo.zone/gemfeed/2023-07-17-career-guide-and-soft-skills-book-notes.gmi 2023-07-17T04:56:20+03:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org These notes are of two books by 'John Sommez' I found helpful. I also added some of my own keypoints to it. These notes are mainly for my own use, but you might find them helpful, too. @@ -336,7 +461,7 @@ gemini://foo.zone/gemfeed/2023-06-01-kiss-server-monitoring-with-gogios.gmi 2023-06-01T21:10:17+03:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org Gogios is a minimalistic and easy-to-use monitoring tool I programmed in Google Go designed specifically for small-scale self-hosted servers and virtual machines. The primary purpose of Gogios is to monitor my personal server infrastructure for `foo.zone`, my MTAs, my authoritative DNS servers, my NextCloud, Wallabag and Anki sync server installations, etc. @@ -613,7 +738,7 @@ http://www.gnu.org/software/src-highlite --> gemini://foo.zone/gemfeed/2023-05-06-the-obstacle-is-the-way-book-notes.gmi 2023-05-06T17:23:16+03:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org These are my personal takeaways after reading 'The Obstacle Is the Way' by Ryan Holiday. This is mainly for my own use, but you might find it helpful too. @@ -723,7 +848,7 @@ http://www.gnu.org/software/src-highlite --> gemini://foo.zone/gemfeed/2023-05-01-unveiling-guprecords:-uptime-records-with-raku.gmi 2023-04-30T13:10:26+03:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org For fun, I am tracking the uptime of various personal machines (servers, laptops, workstations...). I have been doing this for over ten years now, so I have a lot of statistics collected. @@ -905,7 +1030,7 @@ no1 in 455 days, 18:52:44 | at Sun Jul 21 07:37:51 2024 gemini://foo.zone/gemfeed/2023-04-09-algorithms-and-data-structures-in-golang-part-1.gmi 2023-04-09T22:31:42+03:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org This is the first blog post about my Algorithms and Data Structures in Go series. I am not a Software Developer in my day job. In my current role, programming and scripting skills are desirable but not mandatory. I have been learning about Data Structures and Algorithms many years ago at University. I thought it would be fun to revisit/refresh my knowledge here and implement many of the algorithms in Go. @@ -1178,7 +1303,7 @@ ok codeberg.org/snonux/algorithms/sort gemini://foo.zone/gemfeed/2023-04-01-never-split-the-difference-book-notes.gmi 2023-04-01T20:00:17+03:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org These are my personal takeaways after reading 'Never split the difference' by Chris Voss. Note that the book contains much more knowledge wisdom and that these notes only contain points I personally found worth writing down. This is mainly for my own use, but you might find it helpful too. @@ -1333,7 +1458,7 @@ ok codeberg.org/snonux/algorithms/sort gemini://foo.zone/gemfeed/2023-03-25-gemtexter-2.0.0-lets-gemtext-again-2.gmi 2023-03-25T17:50:32+02:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org I proudly announce that I've released Gemtexter version `2.0.0`. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown written in GNU Bash. @@ -1505,7 +1630,7 @@ The remaining content of the Gemtext file... gemini://foo.zone/gemfeed/2023-03-16-the-pragmatic-programmer-book-notes.gmi 2023-03-16T00:55:20+02:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org These are my personal takeaways after reading 'The Pragmatic Programmer' by David Thomas and Andrew Hunt. Note that the book contains much more knowledge wisdom and that these notes only contain points I personally found worth writing down. This is mainly for my own use, but you might find it helpful too. @@ -1614,7 +1739,7 @@ The remaining content of the Gemtext file... gemini://foo.zone/gemfeed/2023-02-26-how-to-shut-down-after-work.gmi 2023-02-26T23:48:01+02:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org Do you need help fully discharging from work in the evenings or for the weekend? Shutting down from work won't just improve your work-life balance; it will also significantly improve the quality of your personal life and work. After a restful weekend, you will be much more energized and productive the next working day. So it should not just be in your own, but also your employers' interest that you fully relax and shut down after work. @@ -1708,7 +1833,7 @@ The remaining content of the Gemtext file... gemini://foo.zone/gemfeed/2023-01-23-why-grapheneos-rox.gmi 2023-01-23T15:31:52+02:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org Art by Joan Stark @@ -1865,7 +1990,7 @@ Art by Joan Stark gemini://foo.zone/gemfeed/2022-12-24-ultrarelearning-java-my-takeaways.gmi 2022-12-24T23:18:40+02:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org As a regular participant in the annual Pet Project competition at work, I always try to find a project where I can learn something new. In this post, I would like to share my takeaways after revisiting Java. You can read about my motivations in my 'Creative universe' post: @@ -1989,7 +2114,7 @@ Art by Joan Stark gemini://foo.zone/gemfeed/2022-11-24-i-tried-emacs-but-i-switched-back-to-neovim.gmi 2022-11-24T11:17:15+02:00 - Paul Buetow + Paul Buetow aka snonux paul@dev.buetow.org Art by \ \_! / __! @@ -2184,3 +2309,6552 @@ nmap ,j :call + + Installing DTail on OpenBSD + + gemini://foo.zone/gemfeed/2022-10-30-installing-dtail-on-openbsd.gmi + 2022-10-30T11:03:19+02:00 + + Paul Buetow aka snonux + paul@dev.buetow.org + + This will be a quick blog post, as I am busy with my personal life now. I have relocated to a different country and am still busy arranging things. So bear with me :-) + +
+

Installing DTail on OpenBSD


+
+Published at 2022-10-30T11:03:19+02:00
+
+
+       ,_---~~~~~----._
+ _,,_,*^____      _____``*g*\"*,
+/ __/ /'     ^.  /      \ ^@q   f
+ @f   |       |  |       |  0 _/
+\`/   \~__((@/ __ \__((@/    \
+ |           _l__l_           I    <--- The Go Gopher
+ }          [______]           I
+ ]            | | |            |
+ ]             ~ ~             |
+ |                            |
+  |                           |
+  |                           |       A       ;
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~|~~~,--,-/ \---,-/|~~,~~~~~~~~~~~~~~~~~~~~~~~~~~~
+                           _|\,'. /|      /|   `/|-.
+                       \`.'    /|      ,            `;.
+                      ,'\   A     A         A   A _ /| `.;
+                    ,/  _              A       _  / _   /|  ;
+                   /\  / \   ,  ,           A  /    /     `/|
+                  /_| | _ \         ,     ,             ,/  \
+                 // | |/ `.\  ,-      ,       ,   ,/ ,/      \/
+                 / @| |@  / /'   \  \      ,              >  /|    ,--.
+                |\_/   \_/ /      |  |           ,  ,/        \  ./' __:..
+                |  __ __  |       |  | .--.  ,         >  >   |-'   /     `
+              ,/| /  '  \ |       |  |     \      ,           |    /
+             /  |<--.__,->|       |  | .    `.        >  >    /   (
+            /_,' \\  ^  /  \     /  /   `.    >--            /^\   |
+                  \\___/    \   /  /      \__'     \   \   \/   \  |
+                   `.   |/          ,  ,                  /`\    \  )
+                     \  '  |/    ,       V    \          /        `-\
+ OpenBSD Puffy --->   `|/  '  V      V           \    \.'            \_
+                       '`-.       V       V        \./'\
+                           `|/-.      \ /   \ /,---`\         kat
+                            /   `._____V_____V'
+                                       '     '
+
+
+This will be a quick blog post, as I am busy with my personal life now. I have relocated to a different country and am still busy arranging things. So bear with me :-)
+
+ In this post, I want to give a quick overview (or how-to) about installing DTail on OpenBSD, as the official documentation only covers Red Hat and Fedora Linux! And this blog post will also be used as my reference!
+
+https://dtail.dev
+
+I am using Rexify for my OpenBSD automation. Check out the following article covering my Rex setup in a little bit more detail:
+
+Let's Encrypt with OpenBSD and Rex
+
+I will also mention some relevant Rexfile snippets in this post!
+
+

Compile it


+
+First of all, DTail needs to be downloaded and compiled. For that, git, go, and gmake are required:
+
+
+$ doas pkg_add git go gmake
+
+
+I am happy that the Go Programming Language is readily available in the OpenBSD packaging system. Once the dependencies got installed, clone DTail and compile it:
+
+
+$ mkdir git
+$ cd git
+$ git clone https://github.com/mimecast/dtail
+$ cd dtail
+$ gmake 
+
+
+You can verify the version by running the following command:
+
+
+$ ./dtail --version
+ DTail  4.1.0  Protocol 4.1  Have a lot of fun!
+$ file dtail
+ dtail: ELF 64-bit LSB executable, x86-64, version 1
+
+
+Now, there isn't any need anymore to keep git, go and gmake, so they can be deinstalled now:
+
+
+$ doas pkg_delete git go gmake
+
+
+One day I shall create an official OpenBSD port for DTail.
+
+

Install it


+
+Installing the binaries is now just a matter of copying them to /usr/local/bin as follows:
+
+
+$ for bin in dserver dcat dgrep dmap dtail dtailhealth; do
+  doas cp -p $bin /usr/local/bin/$bin
+  doas chown root:wheel /usr/local/bin/$bin
+done
+
+
+Also, we will be creating the _dserver service user:
+
+
+$ doas adduser -class nologin -group _dserver -batch _dserver
+$ doas usermod -d /var/run/dserver/ _dserver
+
+
+The OpenBSD init script is created from scratch (not part of the official DTail project). Run the following to install the bespoke script:
+
+
+$ cat <<'END' | doas tee /etc/rc.d/dserver
+#!/bin/ksh
+
+daemon="/usr/local/bin/dserver"
+daemon_flags="-cfg /etc/dserver/dtail.json"
+daemon_user="_dserver"
+
+. /etc/rc.d/rc.subr
+
+rc_reload=NO
+
+rc_pre() {
+    install -d -o _dserver /var/log/dserver
+    install -d -o _dserver /var/run/dserver/cache
+}
+
+rc_cmd $1 &
+END
+$ doas chmod 755 /etc/rc.d/dserver
+
+
+

Rexification


+
+This is the task for setting it up via Rex. Note the . . . ., that's a placeholder which we will fill up more and more during this blog post:
+
+
+desc 'Setup DTail';
+task 'dtail', group => 'frontends',
+   sub {
+      my $restart = FALSE;
+
+      file '/etc/rc.d/dserver':
+        content => template('./etc/rc.d/dserver.tpl'),
+        owner => 'root',
+        group => 'wheel',
+        mode => '755',
+        on_change => sub { $restart = TRUE };
+
+        .
+        .
+        .
+        .
+
+      service 'dserver' => 'restart' if $restart;
+      service 'dserver', ensure => 'started';
+   };
+
+
+

Configure it


+
+Now, DTail is fully installed but still needs to be configured. Grab the default config file from GitHub ...
+
+
+$ doas mkdir /etc/dserver
+$ curl https://raw.githubusercontent.com/mimecast/dtail/master/examples/dtail.json.examples |
+    doas tee /etc/dserver/dtail.json
+
+
+... and then edit it and adjust LogDir in the Common section to /var/log/dserver. The result will look like this:
+
+
+  "Common": {
+    "LogDir": "/var/log/dserver",
+    "Logger": "Fout",
+    "LogRotation": "Daily",
+    "CacheDir": "cache",
+    "SSHPort": 2222,
+    "LogLevel": "Info"
+  }
+
+
+

Rexification


+
+That's as simple as adding the following to the Rex task:
+
+
+file '/etc/dserver',
+  ensure => 'directory';
+
+file '/etc/dserver/dtail.json',
+  content => template('./etc/dserver/dtail.json.tpl'),
+  owner => 'root',
+  group => 'wheel',
+  mode => '755',
+  on_change => sub { $restart = TRUE };
+
+
+

Update the key cache for it


+
+DTail relies on SSH for secure authentication and communication. However, the system user _dserver has no permission to read the SSH public keys from the user's home directories, so the DTail server also checks for available public keys in an alternative path /var/run/dserver/cache.
+
+The following script, populating the DTail server key cache, can be run periodically via CRON:
+
+
+$ cat <<'END' | doas tee /usr/local/bin/dserver-update-key-cache.sh
+#!/bin/ksh
+
+CACHEDIR=/var/run/dserver/cache
+DSERVER_USER=_dserver
+DSERVER_GROUP=_dserver
+
+echo 'Updating SSH key cache'
+
+ls /home/ | while read remoteuser; do
+    keysfile=/home/$remoteuser/.ssh/authorized_keys
+
+    if [ -f $keysfile ]; then
+        cachefile=$CACHEDIR/$remoteuser.authorized_keys
+        echo "Caching $keysfile -> $cachefile"
+
+        cp $keysfile $cachefile
+        chown $DSERVER_USER:$DSERVER_GROUP $cachefile
+        chmod 600 $cachefile
+    fi
+done
+
+# Cleanup obsolete public SSH keys
+find $CACHEDIR -name \*.authorized_keys -type f |
+while read cachefile; do
+    remoteuser=$(basename $cachefile | cut -d. -f1)
+    keysfile=/home/$remoteuser/.ssh/authorized_keys
+
+    if [ ! -f $keysfile ]; then
+        echo 'Deleting obsolete cache file $cachefile'
+        rm $cachefile
+    fi
+done
+
+echo 'All set...'
+END
+$ doas chmod 500 /usr/local/bin/dserver-update-key-cache.sh
+
+
+Note that the script above is a slight variation of the official DTail script. The official DTail one is a bash script, but on OpenBSD, there's ksh. I run it once daily by adding it to the daily.local:
+
+
+$ echo /usr/local/bin/dserver-update-key-cache.sh | doas tee -a /etc/daily.local
+/usr/local/bin/dserver-update-key-cache.sh
+
+
+

Rexification


+
+That's done by adding ...
+
+
+file '/usr/local/bin/dserver-update-key-cache.sh',
+  content => template('./scripts/dserver-update-key-cache.sh.tpl'),
+  owner => 'root',
+  group => 'wheel',
+  mode => '500';
+
+append_if_no_such_line '/etc/daily.local', '/usr/local/bin/dserver-update-key-cache.sh';
+
+
+... to the Rex task!
+
+

Start it


+
+Now, it's time to enable and start the DTail server:
+
+
+$ sudo rcctl enable dserver
+$ sudo rcctl start dserver
+$ tail -f /var/log/dserver/*.log
+INFO|1022-090634|Starting scheduled job runner after 2s
+INFO|1022-090634|Starting continuous job runner after 2s
+INFO|1022-090644|24204|stats.go:53|2|11|7|||MAPREDUCE:STATS|currentConnections=0|lifetimeConnections=0
+INFO|1022-090654|24204|stats.go:53|2|11|7|||MAPREDUCE:STATS|currentConnections=0|lifetimeConnections=0
+INFO|1022-090719|Starting server|DTail 4.1.0 Protocol 4.1 Have a lot of fun!
+INFO|1022-090719|Generating private server RSA host key
+INFO|1022-090719|Starting server
+INFO|1022-090719|Binding server|0.0.0.0:2222
+INFO|1022-090719|Starting scheduled job runner after 2s
+INFO|1022-090719|Starting continuous job runner after 2s
+INFO|1022-090729|86050|stats.go:53|2|11|7|||MAPREDUCE:STATS|currentConnections=0|lifetimeConnections=0
+INFO|1022-090739|86050|stats.go:53|2|11|7|||MAPREDUCE:STATS|currentConnections=0|lifetimeConnect
+.
+.
+.
+Ctr+C
+
+
+As we don't want to wait until tomorrow, let's populate the key cache manually:
+
+
+$ doas /usr/local/bin/dserver-update-key-cache.sh
+Updating SSH key cache
+Caching /home/_dserver/.ssh/authorized_keys -> /var/cache/dserver/_dserver.authorized_keys
+Caching /home/admin/.ssh/authorized_keys -> /var/cache/dserver/admin.authorized_keys
+Caching /home/failunderd/.ssh/authorized_keys -> /var/cache/dserver/failunderd.authorized_keys
+Caching /home/git/.ssh/authorized_keys -> /var/cache/dserver/git.authorized_keys
+Caching /home/paul/.ssh/authorized_keys -> /var/cache/dserver/paul.authorized_keys
+Caching /home/rex/.ssh/authorized_keys -> /var/cache/dserver/rex.authorized_keys
+All set...
+
+
+

Use it


+
+The DTail server is now ready to serve connections. You can use any DTail commands, such as dtail, dgrep, dmap, dcat, dtailhealth, to do so. Checkout out all the usage examples on the official DTail page.
+
+I have installed DTail server this way on my personal OpenBSD frontends blowfish, and fishfinger, and the following command connects as user rex to both machines and greps the file /etc/fstab for the string local:
+
+
+❯ ./dgrep -user rex -servers blowfish.buetow.org,fishfinger.buetow.org --regex local /etc/fstab
+CLIENT|earth|WARN|Encountered unknown host|{blowfish.buetow.org:2222 0xc0000a00f0 0xc0000a61e0 [blowfish.buetow.org]:2222 ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQC9ZnF/LAk14SgqCzk38yENVTNfqibcluMTuKx1u53cKSp2xwHWzy0Ni5smFPpJDIQQljQEJl14ZdXvhhjp1kKHxJ79ubqRtIXBlC0PhlnP8Kd+mVLLHYpH9VO4rnaSfHE1kBjWkI7U6lLc6ks4flgAgGTS5Bb7pLAjwdWg794GWcnRh6kSUEQd3SftANqQLgCunDcP2Vc4KR9R78zBmEzXH/OPzl/ANgNA6wWO2OoKKy2VrjwVAab6FW15h3Lr6rYIw3KztpG+UMmEj5ReexIjXi/jUptdnUFWspvAmzIl6kwzzF8ExVyT9D75JRuHvmxXKKjyJRxqb8UnSh2JD4JN [23.88.35.144]:2222 ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQC9ZnF/LAk14SgqCzk38yENVTNfqibcluMTuKx1u53cKSp2xwHWzy0Ni5smFPpJDIQQljQEJl14ZdXvhhjp1kKHxJ79ubqRtIXBlC0PhlnP8Kd+mVLLHYpH9VO4rnaSfHE1kBjWkI7U6lLc6ks4flgAgGTS5Bb7pLAjwdWg794GWcnRh6kSUEQd3SftANqQLgCunDcP2Vc4KR9R78zBmEzXH/OPzl/ANgNA6wWO2OoKKy2VrjwVAab6FW15h3Lr6rYIw3KztpG+UMmEj5ReexIjXi/jUptdnUFWspvAmzIl6kwzzF8ExVyT9D75JRuHvmxXKKjyJRxqb8UnSh2JD4JN 0xc0000a2180}
+CLIENT|earth|WARN|Encountered unknown host|{fishfinger.buetow.org:2222 0xc0000a0150 0xc000460110 [fishfinger.buetow.org]:2222 ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQDNiikdL7+tWSN0rCaw1tOd9aQgeUFgb830V9ejkyJ5h93PKLCWZSMMCtiabc1aUeUZR//rZjcPHFLuLq/YC+Y3naYtGd6j8qVrcfG8jy3gCbs4tV9SZ9qd5E24mtYqYdGlee6JN6kEWhJxFkEwPfNlG+YAr3KC8lvEAE2JdWvaZavqsqMvHZtAX3b25WCBf2HGkyLZ+d9cnimRUOt+/+353BQFCEct/2mhMVlkr4I23CY6Tsufx0vtxx25nbFdZias6wmhxaE9p3LiWXygPWGU5iZ4RSQSImQz4zyOc9rnJeP1rwGk0OWDJhdKNXuf0kIPdzMfwxv2otgY32/DJj6L [46.23.94.99]:2222 ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQDNiikdL7+tWSN0rCaw1tOd9aQgeUFgb830V9ejkyJ5h93PKLCWZSMMCtiabc1aUeUZR//rZjcPHFLuLq/YC+Y3naYtGd6j8qVrcfG8jy3gCbs4tV9SZ9qd5E24mtYqYdGlee6JN6kEWhJxFkEwPfNlG+YAr3KC8lvEAE2JdWvaZavqsqMvHZtAX3b25WCBf2HGkyLZ+d9cnimRUOt+/+353BQFCEct/2mhMVlkr4I23CY6Tsufx0vtxx25nbFdZias6wmhxaE9p3LiWXygPWGU5iZ4RSQSImQz4zyOc9rnJeP1rwGk0OWDJhdKNXuf0kIPdzMfwxv2otgY32/DJj6L 0xc0000a2240}
+Encountered 2 unknown hosts: 'blowfish.buetow.org:2222,fishfinger.buetow.org:2222'
+Do you want to trust these hosts?? (y=yes,a=all,n=no,d=details): a
+CLIENT|earth|INFO|STATS:STATS|cgocalls=11|cpu=8|connected=2|servers=2|connected%=100|new=2|throttle=0|goroutines=19
+CLIENT|earth|INFO|Added hosts to known hosts file|/home/paul/.ssh/known_hosts
+REMOTE|blowfish|100|7|fstab|31bfd9d9a6788844.h /usr/local ffs rw,wxallowed,nodev 1 2
+REMOTE|fishfinger|100|7|fstab|093f510ec5c0f512.h /usr/local ffs rw,wxallowed,nodev 1 2
+
+
+Running it the second time, and given that you trusted the keys the first time, it won't prompt you for the host keys anymore:
+
+
+❯ ./dgrep -user rex -servers blowfish.buetow.org,fishfinger.buetow.org --regex local /etc/fstab
+REMOTE|blowfish|100|7|fstab|31bfd9d9a6788844.h /usr/local ffs rw,wxallowed,nodev 1 2
+REMOTE|fishfinger|100|7|fstab|093f510ec5c0f512.h /usr/local ffs rw,wxallowed,nodev 1 2
+
+
+

Conclusions


+
+It's a bit of manual work, but it's ok on this small scale! I shall invest time in creating an official OpenBSD port, though. That would render most of the manual steps obsolete, as outlined in this post!
+
+Check out the following for more information:
+
+https://dtail.dev
+https://github.com/mimecast/dtail
+https://www.rexify.org
+
+Other related posts are:
+
+2022-10-30 Installing DTail on OpenBSD (You are currently reading this)
+2022-03-06 The release of DTail 4.0.0
+2021-04-22 DTail - The distributed log tail program
+
+E-Mail your comments to paul at buetow.org :-)
+
+Back to the main site
+
+
+
+ + After a bad night's sleep + + gemini://foo.zone/gemfeed/2022-09-30-after-a-bad-nights-sleep.gmi + 2022-09-30T09:53:23+03:00 + + Paul Buetow aka snonux + paul@dev.buetow.org + + Everyone has it once in a while: A bad night's sleep. Here I attempt to list valuable tips on how to deal with it. + +
+

After a bad night's sleep


+
+Published at 2022-09-30T09:53:23+03:00; Updated at 2022-10-12
+
+
+               z
+                z
+                 Z
+       .--.  Z Z
+      / _(c\   .-.     __
+     | / /  '-;   \'-'`  `\______
+     \_\/'/ __/ )  /  )   |      \--,
+     | \`""`__-/ .'--/   /--------\  \
+      \\`  ///-\/   /   /---;-.    '-'
+jgs                (________\  \
+                             '-'
+
+
+Everyone has it once in a while: A bad night's sleep. Here I attempt to list valuable tips on how to deal with it.
+
+

Don't take the day off.


+
+Don't take a day off after not sleeping enough the previous night. That would be wasting the holiday allowance. It wouldn't be possible to enjoy my free time anyway, so why not just work? There's still a way for an IT Engineer to be productive (sometimes even more) with half or less of the concentration power available!
+
+

Start work early


+
+Probably I am already awake early and am unable to fall asleep again. My strategy here is to "attack" the day: Start work early and finish early. The early bird will also encounter fewer distractions from colleagues.
+
+

Sweat the small stuff


+
+There's never a shortage of small items to hook off my list. Most of these items don't require my full concentration power, and I will be happy to get them off my list so that the next day, after a good night's sleep, I can immerse myself again in focused, deep work with all concentration powers at hand.
+
+Examples of "small work items" are:
+
+
    +
  • Tidying up the workspace.
  • +
  • Installing pending computer software updates.
  • +
  • Going through the work backlog: Create new tickets, close obsolete ones, and roughly pre-plan upcoming work.
  • +
  • Finishing off the easy tickets from the current sprint.
  • +
  • Going through any tedious paperwork.
  • +
  • Catch up with the journal and mark off all trivial action items.
  • +

+

Enter the flow state


+
+I find it easy to enter the "flow state" after a bad night's sleep. All I need to do is to put on some ambient music (preferably instrumental chill house) and start to work on a not-too-difficult ticket.
+
+Usually, the "flow state" is associated with deep-focused work, but deep-focused work isn't easily possible under sleep deprivation. It's still possible to be in the flow by working on more manageable tasks and leaving the difficult ones for the next day.
+
+

Reschedule meetings


+
+I find engaging in discussions and demanding meetings challenging after a lousy night's sleep. I still attend the sessions I am invited to as "only" a participant, but I prefer to reschedule all meetings I am the primary driver of.
+
+This, unfortunately, also includes interviews. Interviews require full concentration power. So for interviews, I would find a colleague to step in for me or ask to reschedule the interview altogether. Everything else wouldn't make it justice and would waste everyone's time!
+
+

Invent


+
+The mind works differently under sleep deprivation: It's easier to invent new stuff as it's easier to have a look at things from different perspectives. Until an hour ago, I didn't know yet what I would be blogging about for this month, and then I just started writing this, and it took me only half an hour to write the first draft of this blog post!
+
+

Fast


+
+I don't eat breakfast, and I don't eat lunch on these days. I only have dinner. Not eating means my mind doesn't get foggy, and I keep up the work momentum. This is called intermittent fasting, which not only generally helps to keep the weight under control and boosts the concentration power. Furthermore, intermittent fasting is healthy. You should include it in your routine, even after a good night's sleep.
+
+

Stretch


+
+I won't have enough energy for strenuous physical exercise on those days, but a 30 to a 60-minute stretching session can make the day. Stretching will even hurt less under sleep deprivation! The stretching could also be substituted with a light Yoga session.
+
+

Walk


+
+Walking is healthy, and the time can be used to listen to interesting podcasts. The available concentration power might not be enough for more sophisticated audio literature. I will have enough energy for one or two daily walks (~10k steps for the day in total). Sometimes, I listen to music during walks. I also try to catch the bright sunlight.
+
+

Red Bull


+
+I don't think that Red Bull is a healthy drink. But once in a while, a can in the early afternoon brings wonders, and productivity will skyrocket. Other than Red Bull, drink a lot of water throughout the day. Don't forget to drink the sugar-free version; otherwise, your intermittent fast will be broken.
+
+

Power nap


+
+I don't know how to "enforce" a nap, but sometimes I manage to power nap, and it helps wonders. A 30-minute nap sometimes brings me back to normal. If you don't tend to fast as you are too hungry, it helps to try to nap approximately 30 minutes after eating something.
+
+

Don't take anything personally.


+
+It's much more challenging to keep the mind "under control" in this state. Every annoyance can potentially upset, which could reflect on the work colleagues. It is wise to attempt to go with a positive attitude into the day, always smile and be polite to the family and colleagues at work. Don't let anything drop out to the people next; they don't deserve it as they didn't do anything wrong! Also, remember, it can't be controlled at all. It's time to let go of the annoyances for the day.
+
+

Meditate


+
+To keep the good vibe, it helps to meditate for 10 minutes. Meditation must nothing be fancy. It can be just lying on the sofa and observing your thoughts as they come and go. Don't judge your thoughts, as that could put you in a negative mood. It's not necessary to sit in an uncomfortable Yoga pose, and it is not required to chant "Ohhmmmmm".
+
+

Write things down


+
+Sometimes something requiring more concentration power demands time. This is where it helps to write a note in a journal and return to it another day. This doesn't mean slacking off but managing the rarely available concentration power for the day. I might repeat myself: Today, sweat all the small stuff. Tomorrow, do the deep-focused work on that crucial project again.
+
+It's easier to forget things on those days, so everything should be written down so that it can be worked off later. Things written down will not be overlooked!
+
+

Social media


+
+I wouldn't say I like checking social media, as it can consume a lot of time and can become addictive. But once in a while, I want to catch up with my "networks". After a bad night's sleep, it's the perfect time to check your social media. Once done, you don't have to do it anymore for the next couple of days!
+
+E-Mail your comments to paul at buetow.org :-)
+
+Back to the main site
+
+
+
+ + Gemtexter 1.1.0 - Let's Gemtext again + + gemini://foo.zone/gemfeed/2022-08-27-gemtexter-1.1.0-lets-gemtext-again.gmi + 2022-08-27T18:25:57+01:00 + + Paul Buetow aka snonux + paul@dev.buetow.org + + I proudly announce that I've released Gemtexter version `1.1.0`. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown written in GNU Bash. + +
+

Gemtexter 1.1.0 - Let's Gemtext again


+
+Published at 2022-08-27T18:25:57+01:00
+
+
+-=[ typewriter ]=-  1/98
+
+       .-------.
+      _|~~ ~~  |_
+    =(_|_______|_)=
+      |:::::::::|
+      |:::::::[]|
+      |o=======.|
+ jgs  `"""""""""`
+
+
+I proudly announce that I've released Gemtexter version 1.1.0. What is Gemtexter? It's my minimalist static site generator for Gemini Gemtext, HTML and Markdown written in GNU Bash.
+
+https://codeberg.org/snonux/gemtexter
+
+It has been around a year since I released the first version 1.0.0. Although, there aren't any groundbreaking changes, there have been a couple of smaller commits and adjustments. I was quite surprised that I received a bunch of feedback and requests about Gemtexter so it means that I am not the only person in the universe actually using it.
+
+

What's new?


+
+

Automatic check for GNU version requirements


+
+Gemtexter relies on the GNU versions of the tools grep, sed and date and it also requires the Bash shell in version 5 at least. That's now done in the check_dependencies() function:
+
+ +
check_dependencies () {
+    # At least, Bash 5 is required
+    local -i required_version=5
+    IFS=. read -ra version <<< "$BASH_VERSION"
+    if [ "${version[0]}" -lt $required_version ]; then
+        log ERROR "ERROR, \"bash\" must be at least at major version $required_version!"
+        exit 2
+    fi
+
+    # These must be the GNU versions of the commands
+    for tool in $DATE $SED $GREP; do
+        if ! $tool --version | grep -q GNU; then
+            log ERROR "ERROR, \"$tool\" command is not the GNU version, please install!"
+            exit 2
+        fi
+    done
+}
+
+
+Especially macOS users didn't read the README carefully enough to install GNU Grep, GNU Sed and GNU Date before using Gemtexter.
+
+

Backticks now produce inline code blocks in the HTML output


+
+The Gemtext format doesn't support inline code blocks, but Gemtexter now produces inline code blocks (means, small code fragments can be placed in the middle of a paragraph) in the HTML output when the code block is enclosed with Backticks. There were no adjustments required for the Markdown output format, because Markdown supports it already out of the box.
+
+

Cache for Atom feed generation


+
+The Bash is not the most performant language. Gemtexter already takes a couple of seconds only to generate the Atom feed for around two hand full of articles on my slightly underpowered Surface Go 2 Linux tablet. Therefore, I introduced a cache, so that subsequent Atom feed generation runs finish much quicker. The cache uses a checksum of the Gemtext .gmi file to decide whether anything of the content has changed or not.
+
+

Input filter support


+
+Once your capsule reaches a certain size, it can become annoying to re-generate everything if you only want to preview the HTML or Markdown output of one single cont